<?php
namespace Specialistaweb\Soho\Controller;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use Specialistaweb\Soho\Domain\Model\Closed;
use Specialistaweb\Soho\Domain\Model\Exceptions;
use Specialistaweb\Soho\Domain\Model\Holiday;
use Specialistaweb\Soho\Domain\Service\Common;

//use  Specialistaweb\Soho\Domain\Model\Closed as ClosedHours;
//use  Specialistaweb\Service\CommonMethods as ClosedHours;
/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Giulia Tuveri <at@specialistaweb.it>, specialistaweb
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * NormalController
 */
class NormalController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * normalRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\NormalRepository
     * @inject
     */
    protected $normalRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\ClosedRepository
     * @inject
     */

    protected $closedRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\HolidayRepository
     * @inject
     */

    protected $holidayRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\ExceptionsRepository
     * @inject
     */

    protected $exceptionsRepository = NULL;

    /**
     * @var \TYPO3\CMS\Extbase\Configuration\ConfigurationManager
     */
    protected $configurationManager;



    function __construct()
    {
	
	$this->sohoTimeFrom = mktime(0,0,0,date('m'),date('d'),date('y'));
	$this->sohoTodayWeekDay = date('D');
	\TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('it', 'feSoho');
    }

    /**
     * action listfull
     *
     * @return void
     */
     
    public function listonlyAction()
    {
        $data = $this->configurationManager->getContentObject()->data;
	if ($data['select_key'] == "LISTONLY") {
		$this->redirect("list",'');
	} else {
		$this->redirect("short",'');
    	}
    }

    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {

	$cah = GeneralUtility::makeInstance('Specialistaweb\\Soho\\Service\\Common');

	// set timefrom as today hour 00:00:00  
	$timefrom = $this->sohoTimeFrom;

        $data = $this->configurationManager->getContentObject()->data;
	$storagePids = Array();
	$storagePids = explode(',',$data['pages']);

	$dateFormat = $this->settings['dateformat'] ? $this->settings['dateformat'] : $this->settings['dateFormat'];
	$timeFormat = $this->settings['timeformat'] ? $this->settings['timeformat'] : $this->settings['timeFormat'];

	$normals = $this->normalRepository->findAllMinusEndtime($storagePids,$timefrom);
	$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('normals', $normals);

	$closed = $this->closedRepository->findAllMinusEndtime($storagePids,$timefrom);
	$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('closedh', $closed);

	//check for Exceptions 
        $exceptions = $this->exceptionsRepository->findAllMinusEndtime($storagePids,$timefrom);
	if(count($exceptions) > 0) {
		foreach($exceptions as $exception) {
			$AMPMHours = $cah->makeAMPMhours(
				$exception->getAmf(),
				$exception->getAmt(),
				$exception->getPmf(),
				$exception->getPmt(),
				$timeFormat
			);
			$exception->setAmpmhours($AMPMHours);  
		}
	}
	$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('exceptionh', $exceptions);

        $holiday = $this->holidayRepository->findAllMinusEndtime($storagePids,$timefrom);
	$this->view->assign('dateFormat',$dateFormat);
	$this->view->assign('holidayh', $holiday);

    }

    // prima era: public function showAction(\Specialistaweb\Soho\Domain\Model\Normal $normal)
    /**
     * action show
     *
     * @param \Specialistaweb\Soho\Domain\Model\Normal $normal
     * @return void
     */
    public function showAction()
    {
        $normals = $this->normalRepository->findAll();

        //$normals = $this->normalRepository->getLastNormal();
        /*
        	// stampa ciclo di tutto...
        	//$normalsTemp  = $this->viewData['normals'];
                $this->view->assign('normals', $normals);
        
                // var definita al volo
        	$test = array();
        	$test[key1] ="hello sono qui e mi stampi";
                $this->view->assign('test', $test);
        
        	$title = "titolo di prova, sono qui e mi stampi";
                $this->view->assign('title', $title);
        */
        
        //$commonClassName =  "Specialistaweb\Soho\Domain\Service\Common";
        // non va boh! ---> $ca = GeneralUtility::makeInstance($commonClassName);
        //$ca = GeneralUtility::makeInstance('Specialistaweb\\Soho\\Service\\Common');
        //$ca = GeneralUtility::makeInstance('Common');
        // non va $mode = $this->cObj->data["select_key"];
        //$mode = 'ciccio';
        //$cah->setName('mode: ' . $mode . ' <-- prova con classe estesa in domain/model');
        //$this->
        //$obj  = new  Specialistaweb\Soho\Utility\CommonMethods;
        foreach ($normals as $normal) {
            /*      $hours = $this->objectManager->get('Specialistaweb\\Soho\\Domain\\Model\\Normal');
                    $hours->setName("Gigi");
                    */
            
            $i++;
            $newTitle = $normal->getName();
            //$newName = $normal[name];
            $normal->setName($i . ') Orario: (closed: ' . $ca->getName() . ') - > ' . $newTitle);
            $this->view->assign('normals', $normals);
        }

    }
    
    /**
     * action short
     *
     * @return void
     */
    public function shortAction()
    {
        //$normals = $this->normalRepository->findAll();
        //$this->view->assign('normals', $normals);
	//$this->initTime();

        /***
         * come leggere i dati del plugin in azione
         * es. header, title, subheader e altri campi tt_content
         **/
	// Get the data object (contains the tt_content fields)
        $data = $this->configurationManager->getContentObject()->data;

	/*
	if ($data['select_key'] == "LISTONLY") {
		$this->redirect("list",'');
	}
	*/

	$storagePids = Array();
	$storagePids = explode(',',$data['pages']);
//print_r($settings);
	$openingstatus = Array();

	$cah = GeneralUtility::makeInstance('Specialistaweb\\Soho\\Service\\Common');

        $this->view->assign('todayDate', $this->sohoTimeFrom);

	//check for Exceptions 
	$exceptions = $this->exceptionsRepository->checkIfException( $storagePids, $this->sohoTimeFrom);

	if(count($exceptions) > 0) {
	        $this->view->assign('openingstatus', $exceptions);
		foreach($exceptions as $exception) {
			$AMPMHours = $cah->makeAMPMhours(
				$exception->getAmf(),
				$exception->getAmt(),
				$exception->getPmf(),
				$exception->getPmt(),
				"H.i"
			);
		//echo $AMPMHours;
        	$this->view->assign('AMPMHours', $AMPMHours);
		}
                return;
	}

	//check for Holiday 
	$holidays = $this->holidayRepository->checkIfHoliday( $storagePids, $this->sohoTimeFrom);
	if(count($holidays) > 0) {
	        $this->view->assign('openingstatus', $holidays);
                return;
	}

	// check for Closed
	$closed = $this->closedRepository->checkIfClosed( $storagePids, $this->sohoTimeFrom);
	if(count($closed) > 0) {
	        $this->view->assign('openingstatus', $closed);
                return;
	}

	//check for Normals 
	$normals = $this->normalRepository->checkIfNormal( $storagePids, $this->sohoTimeFrom);

        $toDayAmf = "get" . $this->sohoTodayWeekDay . "amf";
        $toDayAmt = "get" . $this->sohoTodayWeekDay . "amt";
        $toDayPmf = "get" . $this->sohoTodayWeekDay . "pmf";
        $toDayPmt = "get" . $this->sohoTodayWeekDay . "pmt";

	if(count($normals) > 0) {
		foreach($normals as $normal) {
			$AMPMHours = $cah->makeAMPMhours(
				$normal->$toDayAmf(),
				$normal->$toDayAmt(),
				$normal->$toDayPmf(),
				$normal->$toDayPmt(),
				"H.i"
			);
			$this->view->assign('AMPMHours', $AMPMHours);
		}
	        $this->view->assign('openingstatus', $normals);
	}

	// raw output
	//print_r($data);

	//lettura in una variabile
	//$modus = $data["select_key"];
	//echo "CODE: " . $modus;


        // Append flexform values
        //$this->configurationManager->getContentObject()->readFlexformIntoConf($data['pi_flexform'], $data);

        // Assign to template
        //$this->view->assign('data', $data);

        // Append flexform values
        //$this->configurationManager->getContentObject()->readFlexformIntoConf($data['pi_flexform'], $data);
        //$this->view->assign('data', $data);
 
	// Instance of Common (service) classes...

 
	// $this->time = $cah->setDate($time,"d-m-Y");
        //$this->view->assign('todayDate', $this->time);
        //$this->view->assign('settings', $settings);
        
    }
    
    /**
     * action calendar
     *
     * @return void
     */
    public function calendarAction()
    {
        
    }

}
