<?php

namespace Specialistaweb\Soho\Controller;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use Specialistaweb\Soho\Domain\Model\Closed;
use Specialistaweb\Soho\Domain\Model\Exceptions;
use Specialistaweb\Soho\Domain\Model\Holiday;
use Specialistaweb\Soho\Domain\Service\Common;

//use  Specialistaweb\Soho\Domain\Model\Closed as ClosedHours;
//use  Specialistaweb\Service\CommonMethods as ClosedHours;
/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Giulia Tuveri <at@specialistaweb.it>, specialistaweb
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * NormalController
 */
class NormalController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * normalRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\NormalRepository
     * @inject
     */
    protected $normalRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\ClosedRepository
     * @inject
     */

    protected $closedRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\HolidayRepository
     * @inject
     */

    protected $holidayRepository = NULL;

    /**
     * closedRepository
     *
     * @var \Specialistaweb\Soho\Domain\Repository\ExceptionsRepository
     * @inject
     */

    protected $exceptionsRepository = NULL;

    /**
     * @var \TYPO3\CMS\Extbase\Configuration\ConfigurationManager
     */
    protected $configurationManager;



    function __construct()
    {
	// reads the content object data - es. 13 dicembre 2016 : 1481583600
	//$this->sohoTimeFrom = mktime(0,0,0,date('m'),date('d'),date('y'));
	$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Object\\ObjectManager');    
	$configurationManager = $objectManager->get('TYPO3\\CMS\\Extbase\\Configuration\\ConfigurationManager');
	$this->sohoSettings = $configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_SETTINGS);   
	$this->sohoTimeFrom = $this->sohoSettings['simulatedate'] ? $this->sohoSettings['simulatedate'] :  mktime(0,0,0,date('m'),date('d'),date('y'));

	//test: $this->sohoTimeFrom =  1481983600;
	$this->sohoWeekDays = array('Mon','Tue','Wed','Thu','Fri','Sat','Sun');
	$this->sohoTodayWeekDay = date('D',$this->sohoTimeFrom);
	\TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('it', 'feSoho');
    }

    /**
     * action listfull
     *
     * @return void
     */

    public function listonlyAction()
    {
        $data = $this->configurationManager->getContentObject()->data;
	if ($data['select_key'] == "LISTONLY") {
		$this->redirect("list",'');
	} else {
		$this->redirect("short",'');
    	}
    }

    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {

	$cah = GeneralUtility::makeInstance('Specialistaweb\\Soho\\Service\\Common');

	// set timefrom as today hour 00:00:00  
	$timefrom = $this->sohoTimeFrom;

	// assigns today Date to the view
        $this->view->assign('todayDate', $this->sohoTimeFrom);

        $data = $this->configurationManager->getContentObject()->data;
	$storagePids = Array();
	$storagePids = explode(',',$data['pages']);

	$dateFormat = $this->settings['dateformat'] ? $this->settings['dateformat'] : $this->settings['dateFormat'];
	$timeFormat = $this->settings['timeformat'] ? $this->settings['timeformat'] : $this->settings['timeFormat'];
	$this->view->assign('dateFormat',$dateFormat);

	$normals = $this->normalRepository->findAllMinusEndtime($storagePids,$timefrom);
	$ampmHours = Array();
	if(count($normals) > 0) {
	   foreach($normals as $weekday) {
		foreach($this->sohoWeekDays as $openTime) {
			$methodName = "get" . $openTime;
			$amf = $methodName . "amf";
			$amt = $methodName . "amt";
			$pmf = $methodName . "pmf";
			$pmt = $methodName . "pmt";
			$setamf = "set" . $openTime . "amf";
			$currentStatus = $cah->makeAMPMhours(
				$weekday->$amf(),
				$weekday->$amt(),
				$weekday->$pmf(),
				$weekday->$pmt(),
				$timeFormat
			);

			//beccto, e' qui
			$weekday->$setamf($currentStatus);
		}
	   }
	}
	//$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('normals', $normals);

//	$this->view->assign('testoutput', $testqui);

	$closed = $this->closedRepository->findAllMinusEndtime($storagePids,$timefrom);
	//$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('closedh', $closed);

	//check for Exceptions 
        $exceptions = $this->exceptionsRepository->findAllMinusEndtime($storagePids,$timefrom);
	if(count($exceptions) > 0) {
		foreach($exceptions as $exception) {
			$AMPMHours = $cah->makeAMPMhours(
				$exception->getAmf(),
				$exception->getAmt(),
				$exception->getPmf(),
				$exception->getPmt(),
				$timeFormat
			);
			$exception->setAmpmhours($AMPMHours);  
		}
	}
	//$this->view->assign('dateFormat',$dateFormat);
        $this->view->assign('exceptionh', $exceptions);

        $holiday = $this->holidayRepository->findAllMinusEndtime($storagePids,$timefrom);
	//$this->view->assign('dateFormat',$dateFormat);
	$this->view->assign('holidayh', $holiday);

    }

    /**
     * action short
     *
     * @return void
     */
    public function shortAction()
    {
	// reads the content object data
        $data = $this->configurationManager->getContentObject()->data;
	$storagePids = Array();
	$storagePids = explode(',',$data['pages']);

	// init openingstatus Array
	$openingstatus = Array();

	// makes new instance for common utilities
	$cah = GeneralUtility::makeInstance('Specialistaweb\\Soho\\Service\\Common');

	// assigns today Date to the view
        $this->view->assign('todayDate', $this->sohoTimeFrom);

	//repo quueries  for Exceptions, Holiday, Closed, Normals
	//$exceptions = $this->exceptionsRepository->checkIfException( $storagePids, $this->sohoTimeFrom);
/*
	$closed = $this->closedRepository->findAllMinusEndtime( $storagePids, $this->sohoTimeFrom);
	\TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump($this->sohoTimeFrom);
	\TYPO3\CMS\Extbase\Utility\DebuggerUtility::var_dump($closed);
*/

	// init empty array from today + 92 days, each day is set to 0
	$limitDays = 92;
	$cah->initEmptyDays($this->sohoTimeFrom,$limitDays);

	$fillNormal = $this->normalRepository->findAllMinusEndtime($storagePids,$this->sohoTimeFrom,ASC,1);
	$fillHoliday = $this->holidayRepository->findAllMinusEndtime($storagePids,$this->sohoTimeFrom);
	$fillException = $this->exceptionsRepository->findAllMinusEndtime($storagePids,$this->sohoTimeFrom);
	$fillClosed = $this->closedRepository->findAllMinusEndtime($storagePids,$this->sohoTimeFrom);

	$maxTimeLimit = $this->sohoTimeFrom + ($limitDays * 86400);

	// fill with normal
	foreach($fillNormal as $fill) {
		$start = $fill->getStarttimenormaldate();
		$start = $start < $this->sohoTimeFrom ? $this->sohoTimeFrom : $start;
		$end = $fill->getEndtimenormaldate();
		$end = $end > $maxTimeLimit ? $maxTimeLimit : $end;
		$weekDayStatus = Array();
		foreach($this->sohoWeekDays as $openTime) {
			$methodName = "get" . $openTime;
			$amf = $methodName . "amf";
			$amf = $methodName . "amf";
			$amt = $methodName . "amt";
			$pmf = $methodName . "pmf";
			$pmt = $methodName . "pmt";

			$currentStatus = $cah->makeAMPMhours(
				$fill->$amf(),
				$fill->$amt(),
				$fill->$pmf(),
				$fill->$pmt(),
				$timeFormat
			);

			if($currentStatus) {
				$weekDayStatus[$openTime] = 1;
			} else {
				$weekDayStatus[$openTime] = '';
			}
		}

 		$cah->setStatusDay($start,$end,1,$weekDayStatus);
	}

	// fill with Holiday
	foreach($fillHoliday as $fill) {
		$start = $fill->getStarttimeholidaydate();
		$start = $start < $this->sohoTimeFrom ? $this->sohoTimeFrom : $start;
		$end = $fill->getEndtimeholidaydate();
		$cah->setStatusDay($start,$end,'');
	}

	// fill with Closed
	foreach($fillClosed as $fill) {
		$start = $fill->getStarttimecloseddate();
		$start = $start < $this->sohoTimeFrom ? $this->sohoTimeFrom : $start;
		$end = $fill->getEndtimecloseddate();
		$cah->setStatusDay($start,$end,'');
	}

	// fill with Exceptions
	foreach($fillException as $fill) {
		$start = $fill->getStarttimeexceptionsdate();
		$start = $start < $this->sohoTimeFrom ? $this->sohoTimeFrom : $start;
		$end = $fill->getEndtimeexceptionsdate();
		$cah->setStatusDay($start,$end,1);
	}

	// delete empty records from array
	$cah->statusDay = array_filter($cah->statusDay);

	// read first key and adjust it
	$reopenDate = key($cah->statusDay);
	if($reopenDate == $this->sohoTimeFrom) {
		$reopenDate = '';
	}

	//check for Exceptions
	$exceptions = $this->exceptionsRepository->checkIfException( $storagePids, $this->sohoTimeFrom);
	if(count($exceptions) > 0) {
	        $this->view->assign('openingstatus', $exceptions);
		foreach($exceptions as $exception) {
			$AMPMHours = $cah->makeAMPMhours(
				$exception->getAmf(),
				$exception->getAmt(),
				$exception->getPmf(),
				$exception->getPmt(),
				"H.i"
			);
		//echo $AMPMHours;
        	$this->view->assign('AMPMHours', $AMPMHours);
	        $this->view->assign('reopendate', '');
		}
                return;
	}

	$holidays = $this->holidayRepository->checkIfHoliday($storagePids, $this->sohoTimeFrom);
	if(count($holidays) > 0) {
	        $this->view->assign('openingstatus', $holidays);
	        $this->view->assign('reopendate', $reopenDate);
                return;
	}


	$closed = $this->closedRepository->checkIfClosed($storagePids, $this->sohoTimeFrom);
	if(count($closed) > 0) {
	        $this->view->assign('openingstatus', $closed);
	        $this->view->assign('reopendate', $reopenDate);
                return;
	}


	$normals = $this->normalRepository->checkIfNormal($storagePids, $this->sohoTimeFrom);
	if(count($normals) > 0) {

	        $toDayAmf = "get" . $this->sohoTodayWeekDay . "amf";
        	$toDayAmt = "get" . $this->sohoTodayWeekDay . "amt";
	        $toDayPmf = "get" . $this->sohoTodayWeekDay . "pmf";
        	$toDayPmt = "get" . $this->sohoTodayWeekDay . "pmt";

		foreach($normals as $normal) {
			$AMPMHours = $cah->makeAMPMhours(
				$normal->$toDayAmf(),
				$normal->$toDayAmt(),
				$normal->$toDayPmf(),
				$normal->$toDayPmt(),
				"H.i"
			);

			$this->view->assign('AMPMHours', $AMPMHours);
		}

	        $this->view->assign('openingstatus', $normals);

		if($statusDay[$this->sohoTimeFrom]) {
		        $this->view->assign('reopendate', '');
		} else {
		        $this->view->assign('reopendate', $reopenDate);
		}

		// remove the file tmp created before, if the normal oh is available
		if(file_exists('uploads/tx_soho/tmp_email_sent.txt')) {
			unlink('uploads/tx_soho/tmp_email_sent.txt');
		}

	} else {

		// no normal oh is availble, so creates a tmp file and send an email
		if(!file_exists( 'uploads/tx_soho/tmp_email_sent.txt') &&
			$this->sohoSettings['emailnotification']
		) {

			// do not exsist the file, so that creates is
			exec('touch uploads/tx_soho/tmp_email_sent.txt',$res);

			// send mail
			$mail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Mail\\MailMessage');

			// Prepare and send the message
			$mail

			// Give the message a subject
			   ->setSubject('soho stopped in: ' .  $GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'])

			   // Set the From address with an associative array
			   ->setFrom(array( $GLOBALS['TYPO3_CONF_VARS']['MAIL']['defaultMailFromAddress'] =>  $GLOBALS['TYPO3_CONF_VARS']['MAIL']['defaultMailFromName'] ))

			   // Set the To addresses with an associative array
			   ->setTo(array($this->sohoSettings['emailnotification'] => "automatic message"))

			   // Give it a body
			   ->setBody('Ext soho do not displays more any normal opening hour. Please provide.')

			   // And finally do send it
	   		   ->send()
	 		;
		}	
	}

    }
}
