<?php
namespace Specialistaweb\Soho\Domain\Repository;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Giulia Tuveri <at@specialistaweb.it>, specialistaweb
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * The repository for Closed
 */
class ClosedRepository extends \TYPO3\CMS\Extbase\Persistence\Repository
{

    // Example for repository wide settings
    public function initializeObject()
    {
        /** @var $querySettings \TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings */
        $querySettings = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\Typo3QuerySettings');
        // go for $defaultQuerySettings = $this->createQuery()->getQuerySettings(); if you want to make use of the TS persistence.storagePid with defaultQuerySettings(), see #51529 for details
        // don't add the pid constraint
        $querySettings->setRespectStoragePage(FALSE);
        // set the storagePids to respect
        $querySettings->setStoragePageIds(array(1, 26, 989));
        // don't add fields from enablecolumns constraint
        // this function is deprecated!
        #$querySettings->setRespectEnableFields(FALSE);
        // define the enablecolumn fields to be ignored
        // if nothing else is given, all enableFields are ignored
        $querySettings->setIgnoreEnableFields(FALSE);
        // define single fields to be ignored
	// $querySettings->setEnableFieldsToBeIgnored(array('disabled', 'starttime'));
        // add deleted rows to the result
        // $querySettings->setIncludeDeleted(TRUE);
        // don't add sys_language_uid constraint
        $querySettings->setRespectSysLanguage(FALSE);
        // perform translation to dedicated language
        #$querySettings->setSysLanguageUid(42);
        $this->setDefaultQuerySettings($querySettings);
    }
    
    // Example for a function setup changing query settings
    public function getLastClosed($pageUids)
    {
        $query = $this->createQuery();
        $query->setLimit(1);
        // solo l'ultimo... no so in che ordine ?
        // don't add the pid constraint
        $query->getQuerySettings()->setStoragePageIds($pageUids);

        return $query->execute();
    }

    // Example for a function setup changing query settings
    // get all records with time() - now <  endtimenormaldate
    public function findAllMinusEndtime ($pageUids = NULL, $timefrom = 0, $ordering = "ASC"  )
    {
        $query = $this->createQuery();

        switch ($ordering) {
                case "ASC":
                        $query->setOrderings(
                                array (
                                        'starttimecloseddate' =>  \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING
                                )
                        );
                        break;
                case "DESC":
                        $query->setOrderings(
                                array (
                                        'starttimecloseddate' =>  \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_DESCENDING
                                )
                        );
                break;

        }

        $query->matching(
                $query->logicalAnd(
                        $query->greaterThanOrEqual('endtimecloseddate',$timefrom),
                        $query->equals('sys_language_uid','0'),
                        $query->equals('hidden','0'),
                        $query->equals('deleted','0')                )
        );
        // solo l'ultimo... no so in che ordine ?
        // don't add the pid constraint
        $query->getQuerySettings()->setStoragePageIds($pageUids);

        return $query->execute();
    }

    // Example for a function setup changing query settings
    public function checkIfClosed($pageUids = NULL, $timefrom = 0)
    {
        $query = $this->createQuery();
        $query->setLimit(1);
        $query->setOrderings(
            array (
             'endtimecloseddate' =>  \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING
            )
        );

        // don't add the pid constraint
       $query->matching(
                $query->logicalAnd(
                        $query->greaterThanOrEqual('endtimecloseddate',$timefrom),
                        $query->lessThanOrEqual('starttimecloseddate',$timefrom),
                        $query->equals('hidden','0'),
                        $query->equals('deleted','0'),
                        $query->equals('sys_language_uid','0')
		)
       );

        // solo l'ultimo... no so in che ordine ?
        // don't add the pid constraint
        $query->getQuerySettings()->setStoragePageIds($pageUids);
/*
	$parser = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Persistence\\Generic\\Storage\\Typo3DbQueryParser');  
    	$queryParts = $parser->parseQuery($query); 
    	\TYPO3\CMS\Core\Utility\DebugUtility::debug($queryParts, 'query');
    	\TYPO3\CMS\Core\Utility\DebugUtility::debug(count($query->execute()), 'number of results');
*/
	$result =  $query->execute();
//echo serialize($result);
        return $result;
    }
}
