<?php
namespace Specialistaweb\Soho\Service;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Giulia Tuveri <at@specialistaweb.it>, specialistaweb
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
  * normal, this table contains the opening hours for each day of the week
 */
/* 
*/

class Common 
{

     /**
      * init an empty Array filled with zero's (null = closed)
      * @param $timefrom,  usually today or another date for test
      * @param	$daysForward; numebr of days  (90)  to fill with 0 or 1 
      * returns	  none
      */

      public function initEmptyDays($timefrom,$daysForward) {
//echo "<h1>timefrom: " . $timefrom . " - " . date("d-m-Y h.i", $timefrom) . "</h1>";

	$this->statusDay = Array();
	$endLoop = $timefrom + (86400 * $daysForward);

	for($i=$timefrom; $i < $endLoop; $i=$i+86400) {
		$this->statusDay[$i] = '';
	}
        return;
      }

     /**
      * calculates reopen date, prints out all settings
      * @param $timefrom,  usually today or another date for test
      * @param	$daysForward; numebr of days  (90)  to fill with 0 or 1 
      * returns	  none
      */

      public function setStatusDay($starttime,$endtime,$value,$weekDayStatus = Array()) {

	for($i=$starttime; $i <= $endtime; $i=$i+86400) {

		// ricava  il giorno della settimana, solo per il profilo normal
		if(count($weekDayStatus) > 0) {
			$weekDay = date("D",$i);
			$value = 1;
			if(!$this->statusDay[$i]) {
				if($weekDayStatus[$weekDay]) {
					$value = 1;
				}  else {
					$value = '';
				} 
			}
			$this->statusDay[$i] = $value;
/*
		echo "<br>setto: " . date('d-m-Y',$i) . " value ". $value . " ";
		echo "weekday: " . $weekDay . " weekDayStatus " . $weekDayStatus[$weekDay] . " >>> ";  
*/
		} else {
			$this->statusDay[$i] = $value;
		}
	}
    	return;
      }


     /**
      * calculates reopen date, prints out all settings
      * @param	none
      * returns	content
      */

      public function makeAMPMhours($amf,$amt = 0,$pmf =0,$pmt=0,$timeFormat = "H.i") {
	$AMPMHuman = "";

	// check if $maf is prefilled with the string, otherwise is proceesed to calculate gmdate
	if(is_string($amf)) {
		$amfTmp = explode("-",$amf);
		$amfHour = $amfTmp[0];
	} else {
		$amfHour = $amf ? gmdate($timeFormat,$amf) : 0;
	}

	// gmdate conversion from time using time format
	$amtHour = $amt ? gmdate($timeFormat,$amt) : 0;
	$pmfHour = $pmf ? gmdate($timeFormat,$pmf) : 0;
	$pmtHour = $pmt ? gmdate($timeFormat,$pmt) : 0;


	// check if morning filled
	if(($amfHour && $amtHour) && ($amfHour != $amtHour)) {
		$AMPMHuman = $amfHour . "-" . $amtHour;
	}

	// check  if the opening hour is from AM to PM (continued)
	if($amfHour && $pmtHour && (!$amtHour && !$pmfHour)) {
		$AMPMHuman = $amfHour . "-" . $pmtHour;
		return  $AMPMHuman;
	}

	// check if is opened on PM
	if(($pmfHour && $pmtHour) && ($pmfHour != $pmtHour)) {
		$AMPMHuman .= $AMPMHuman ? " / " : '';
		$AMPMHuman .= $pmfHour . "-" . $pmtHour;
	}

	return  $AMPMHuman;
      }
}
