<?php

namespace Specialistaweb\Soho\Tests\Unit\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 Giulia Tuveri <at@specialistaweb.it>, specialistaweb
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \Specialistaweb\Soho\Domain\Model\Exceptions.
 *
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 * @author Giulia Tuveri <at@specialistaweb.it>
 */
class ExceptionsTest extends \TYPO3\CMS\Core\Tests\UnitTestCase
{
	/**
	 * @var \Specialistaweb\Soho\Domain\Model\Exceptions
	 */
	protected $subject = NULL;

	public function setUp()
	{
		$this->subject = new \Specialistaweb\Soho\Domain\Model\Exceptions();
	}

	public function tearDown()
	{
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getNameReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getName()
		);
	}

	/**
	 * @test
	 */
	public function setNameForStringSetsName()
	{
		$this->subject->setName('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'name',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getTextReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getText()
		);
	}

	/**
	 * @test
	 */
	public function setTextForStringSetsText()
	{
		$this->subject->setText('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'text',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getPagelinkReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setPagelinkForIntSetsPagelink()
	{	}

	/**
	 * @test
	 */
	public function getNewsuidReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setNewsuidForIntSetsNewsuid()
	{	}

	/**
	 * @test
	 */
	public function getAmfReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setAmfForIntSetsAmf()
	{	}

	/**
	 * @test
	 */
	public function getAmtReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setAmtForIntSetsAmt()
	{	}

	/**
	 * @test
	 */
	public function getOmfReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setOmfForIntSetsOmf()
	{	}

	/**
	 * @test
	 */
	public function getPmtReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setPmtForIntSetsPmt()
	{	}

	/**
	 * @test
	 */
	public function getTimeformatReturnsInitialValueForInt()
	{	}

	/**
	 * @test
	 */
	public function setTimeformatForIntSetsTimeformat()
	{	}

	/**
	 * @test
	 */
	public function getNotesReturnsInitialValueForString()
	{
		$this->assertSame(
			'',
			$this->subject->getNotes()
		);
	}

	/**
	 * @test
	 */
	public function setNotesForStringSetsNotes()
	{
		$this->subject->setNotes('Conceived at T3CON10');

		$this->assertAttributeEquals(
			'Conceived at T3CON10',
			'notes',
			$this->subject
		);
	}
}
